; AMPL Script ShortCutter
#SingleInstance force

thisScript_Name=AMPL Script ShortCutter
thisScript_Version=0.1.0
version_CreateShortcut:=thisScript_Version
thisScript_VersionDate=2009.06.25
thisScript_AuthorName=Perry Mowbray (scribbly)
amplWebSite=scribbly.mitupela.net\programmes\farr\ampl

/*
**********************************************************************************
** 	Version History
**********************************************************************************
**  0.1.0 2009.06.14 First Beta Release
**********************************************************************************
*/

optionsListView=Desktop (User)|Desktop (Common)|Start Menu (User)|Start Menu (Common)|StartUp (User)|StartUp (Common)|My Documents (User)|Quick Launch (User)

if (%0%>0){
scriptName = %1%
SplitPath, scriptName, OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
}
Gui, Add, Button, x226 y160 w80 h30 gCreateShortCuts, Create
Gui, Add, Text, x6 y10 w300 h30 , Select the Shortcuts to create`, and click Create
Gui, Add, ListView, x6 y40 w210 h150 Checked -LV0x20, Short Cut Locations
Gui, Add, Button, x226 y60 w80 h20 gAllUser, All User
Gui, Add, Button, x226 y80 w80 h20 gAllCommon, All Common
Gui, Add, Button, x226 y100 w80 h20 gAllLocations, All
Gui, Add, Button, x226 y120 w80 h20 gNoLocations, None
Gui, Add, Button, x226 y140 w80 h20 gInvert, Invert
; Generated using SmartGUI Creator 4.0
Gui, Show, x476 y388 h201 w319, Create Short Cuts
Loop, Parse, optionsListView, |,
{
  if A_LOOPFIELD!=
  {
  	LV_Add("-Check", A_LOOPFIELD )
  }
}
LV_ModifyCol()
Return

GuiClose:
ExitApp

AllUser:
SelectRows("(User)")
Return
AllCommon:
SelectRows("(Common)")
Return
AllLocations:
LV_Modify(0, "Check")
Return
NoLocations:
LV_Modify(0, "-Check")
Return
Invert:
Gui +LastFound
Loop % LV_GetCount()
{
SendMessage, 4140, A_Index - 1, 0xF000, SysListView321  ; 4140 is LVM_GETITEMSTATE.  0xF000 is LVIS_STATEIMAGEMASK.
IsChecked := (ErrorLevel >> 12) - 1  ; This sets IsChecked to true if RowNumber is checked or false otherwise.
if IsChecked
  LV_Modify(A_Index, "-Check")
else
  LV_Modify(A_Index, "Check")
}
Return
SelectRows(stringFilter) {
Loop % LV_GetCount()
	{
	    LV_GetText(RetrievedText, A_Index)
	    if InStr(RetrievedText, stringFilter)
	        LV_Modify(A_Index, "Check")  ; Check each row whose first field contains the filter-text.
	}
}

CreateShortCuts:
RowNumber = 0  ; This causes the first loop iteration to start the search at the top of the list.
if not scriptName
  FileSelectFile, scriptName , 3, , Select the file to shortcut to..., 
If scriptName
{
SplitPath, scriptName, OutFileName, OutDir, OutExtension, OutNameNoExt, OutDrive
Loop
{
    RowNumber := LV_GetNext(RowNumber,"C")  ; Resume the search at the row after that found by the previous iteration.
    if not RowNumber  ; The above returned zero, so there are no more selected rows.
        break
    LV_GetText(RowText, RowNumber)
    if RowText=Desktop (User)
			FileCreateShortcut, %scriptName%, %A_DESKTOP%\%OutNameNoExt%.lnk, , , An AMPL script., C:\Program Files\FindAndRunRobot\Plugins\AMPL\icons\Buuf\Script_Run.ico, , 1, 1
		else if RowText=Desktop (Common)
			FileCreateShortcut, %scriptName%, %A_DESKTOPCOMMON%\%OutNameNoExt%.lnk, %OutDir% , , An AMPL script., C:\Program Files\FindAndRunRobot\Plugins\AMPL\icons\Buuf\Script_Run.ico, , 1, 1
		else if RowText=Start Menu (User)
			FileCreateShortcut, %scriptName%, %A_STARTMENU%\%OutNameNoExt%.lnk, %OutDir%, , An AMPL script., C:\Program Files\FindAndRunRobot\Plugins\AMPL\icons\Buuf\Script_Run.ico, , 1, 1
		else if RowText=Start Menu (Common)
			FileCreateShortcut, %scriptName%, %A_STARTMENUCOMMON%\%OutNameNoExt%.lnk, %OutDir%, , An AMPL script., C:\Program Files\FindAndRunRobot\Plugins\AMPL\icons\Buuf\Script_Run.ico, , 1, 1
		else if RowText=StartUp (User)
			FileCreateShortcut, %scriptName%, %A_Startup%\%OutNameNoExt%.lnk, %OutDir%, , An AMPL script., C:\Program Files\FindAndRunRobot\Plugins\AMPL\icons\Buuf\Script_Run.ico, , 1, 1
		else if RowText=StartUp (Common)
			FileCreateShortcut, %scriptName%, %A_STARTUPCOMMON%\%OutNameNoExt%.lnk, %OutDir%, , An AMPL script., C:\Program Files\FindAndRunRobot\Plugins\AMPL\icons\Buuf\Script_Run.ico, , 1, 1
		else if RowText=My Documents (User)
			FileCreateShortcut, %scriptName%, %A_MYDOCUMENTS%\%OutNameNoExt%.lnk, %OutDir%, , An AMPL script., C:\Program Files\FindAndRunRobot\Plugins\AMPL\icons\Buuf\Script_Run.ico, , 1, 1
		else if RowText=Quick Launch (User)
			FileCreateShortcut, %scriptName%, C:\Documents and Settings\%USERNAME%\application data\microsoft\internet explorer\Quick Launch\%OutNameNoExt%.lnk, %OutDir%, , An AMPL script., C:\Program Files\FindAndRunRobot\Plugins\AMPL\icons\Buuf\Script_Run.ico, , 1, 1

    ;MsgBox The next selected row is #%RowNumber%, whose first field is "%Text%".
}
ExitApp
} else
MsgBox, No file to work with!
Return
