 ' VB Script Document
'********************************************************************
'** Versions
'********************************************************************
'** AMPL Package  				2009.10.12	0.6.2
'********************************************************************
'** FScript.vbs   				2009.10.12	0.5.2
'** CreateShortCut.ahk    2009.06.14  0.1.0
'** Settings.ahk    			2009.10.12  0.1.2
'** Script Editor Package	2009.06.14	0.5.1
'** Recorder              2009.10.09  0.19.0
'** Script Updater        2009.10.12	0.1.2
'********************************************************************
On Error Resume Next

dim displayname: displayname="AMPL"
dim versionstring: versionstring="0.5.2"
dim releasedatestring: releasedatestring="2009.10.12"
dim author: author="scribbly"
updateurl=""
homepageurl="http://scribbly.mitupela.net/programmes/farr/ampl/"
shortdescription="AMPL executes specialised AHK scripts"
longdescription="AMPL executes specialised AHK scripts"
advconfigstring="settings.ahk"
readmestring="about.html"
iconfilename="AMPL.ico"

aliasstr="am"
regexstr="^(am\s{0,1}[nredica]*)\s+(.*)"
regexfilterstr=""
keywordstr=""
scorestr="300"
dim lngScore: lngScore = scorestr * 1
dim thisScore

'where are we?
dim dirCurrent: dirCurrent = ""
dim dirScripts: dirScripts = "Scripts"
dim pathScripts: pathScripts = ""
dim pathINI: pathINI = ""
dim dirIcons: dirIcons = "icons"
dim pathIcons: pathIcons = ""
dim useIcons: useIcons = ""
dim pathCompiler: pathCompiler = ""
dim pathAHK : pathAHK = ""
dim ahk_path: ahk_path = ""

' Scoring Variables
dim preferEnd: preferEnd = 0
dim preferStart: preferStart = 0
dim preferType: preferType = 0

' Icons
dim def_iconExeDelete: def_iconExeDelete="Executable_Delete.ico"
dim def_iconExeRun: def_iconExeRun="Executable_Run.ico"
dim def_iconScriptCompile: def_iconScriptCompile="Script_Compile.ico"
dim def_iconScriptDelete: def_iconScriptDelete="Script_Delete.ico"
dim def_iconScriptEdit: def_iconScriptEdit="Script_Edit.ico"
dim def_iconScriptGlue: def_iconScriptGlue="Script_Glue.ico"
dim def_iconScriptInfo: def_iconScriptInfo="Script_Info.ico"
dim def_iconScriptCreate: def_iconScriptCreate="Script_New.ico"
dim def_iconScriptUpdate: def_iconScriptUpdate="Script_Update.ico"
dim def_iconScriptRun: def_iconScriptRun="Script_Run.ico"
dim def_AllScriptsInfo: def_AllScriptsInfo="Scripts_Info.ico"
dim def_iconAllScriptsOptions: def_iconAllScriptsOptions="Scripts_Options.ico"
dim def_PlugInOptions: def_PlugInOptions="Plug-in_Options.ico"
dim def_iconAMPLHelp: def_iconAMPLHelp="Help.ico"
dim def_iconScriptInstall: def_iconScriptInstall="Script_Install.ico"
dim def_iconScriptRecord: def_iconScriptRecord="Script_Recorder.ico"
dim iconExeDelete: iconExeDelete=""
dim iconExeRun: iconExeRun=""
dim iconScriptCompile: iconScriptCompile=""
dim iconScriptDelete: iconScriptDelete=""
dim iconScriptEdit: iconScriptEdit=""
dim iconScriptGlue: iconScriptGlue=""
dim iconScriptInfo: iconScriptInfo=""
dim iconScriptCreate: iconScriptCreate=""
dim iconScriptUpdate: iconScriptUpdate=""
dim iconScriptRun: iconScriptRun=""
dim AllScriptsInfo: AllScriptsInfo=""
dim iconAllScriptsOptions: iconAllScriptsOptions=""
dim PlugInOptions: PlugInOptions=""
dim iconAMPLHelp: iconAMPLHelp=""
dim iconScriptInstall: iconScriptInstall=""
dim iconScriptRecord: iconScriptRecord=""

' type
UNKNOWN=0
FILE=1
FOLDER=2
ALIAS=3
URL=4
PLUGIN=5
CLIP=5
' Postprocessing
IMMEDIATE_DISPLAY=0
ADDSCORE=1
MATCH_AGAINST_SEARCH=2
' search state
STOPPED=0
SEARCHING=1

function onSearchBegin(querykey, e, queryraw, querynokeyword, modifier, triggermethod)
	'msgbox e
	if e=false then
	  'msgbox queryraw & vbnewline & aliasstr & vbnewline & instr(queryraw , aliasstr )
	  if instr(queryraw , aliasstr ) > 0 then
	  'msgbox "No E!"
			Call FARR.setState(querykey,SEARCHING)
			Call FARR.emitResult(querykey, aliasstr, aliasstr, iconfilename,UNKNOWN,IMMEDIATE_DISPLAY,1000)
			Call FARR.setState(querykey,STOPPED)
		end if
		exit function
	end if
	'msgbox "We have an E"
	

	'msgbox pathIcons
	
        FARR.setState querykey,SEARCHING
 				FARR.emitResult querykey, "Create Script", "amn", iconScriptCreate ,ALIAS, MATCH_AGAINST_SEARCH,1100
 				FARR.emitResult querykey, "Record Script", "amn", iconScriptRecord ,ALIAS, MATCH_AGAINST_SEARCH,1050
 				FARR.emitResult querykey, "Compile Script", "amn", iconScriptCompile ,ALIAS, MATCH_AGAINST_SEARCH,10
 				FARR.emitResult querykey, "Run Script/Executable", "amr", iconScriptRun ,ALIAS, MATCH_AGAINST_SEARCH,1500
 				FARR.emitResult querykey, "Delete Script/Executable", "amd", iconScriptDelete ,ALIAS, MATCH_AGAINST_SEARCH,300
 				FARR.emitResult querykey, "Edit Script", "ame", iconScriptEdit ,ALIAS, MATCH_AGAINST_SEARCH,1000
 				FARR.emitResult querykey, "Script Info", "ama", iconScriptInfo ,ALIAS, MATCH_AGAINST_SEARCH,1000
        FARR.emitResult querykey, "AMPL Options:", dirCurrent & "\settings.ahk /stayopen", iconAllScriptsOptions ,FILE, MATCH_AGAINST_SEARCH,1000
        FARR.emitResult querykey, "AMPL Help:", dirCurrent &  "\about.html /stayopen", iconAMPLHelp ,FILE, IMMEDIATE_DISPLAY,100
        FARR.emitResult querykey, "Scripts Update:", dirCurrent &  "\ScriptUpdate.ahk", iconScriptUpdate ,FILE, MATCH_AGAINST_SEARCH,40
        FARR.emitResult querykey, "Script Install",  "ami", iconScriptInstall ,ALIAS, MATCH_AGAINST_SEARCH,600
        FARR.setState querykey,STOPPED

end function

function onRegexSearchMatch(querykey, queryraw,querynokeyword, modifier, triggermethod)
'On Error Resume Next
  Dim folderScripts
	Dim fileScript, fileExtension

	dim objRegExp: Set objRegExp = New Regexp
	objRegExp.Pattern = regexstr
	objRegExp.Global = True
	objRegExp.IgnoreCase = True

	dim colMatches
	Set colMatches = objRegExp.Execute( queryraw )
	dim amCommand: amCommand = colMatches(0).SubMatches(0)
	dim scriptName: scriptName = colMatches(0).SubMatches(1)

	dim fso: Set fso = CreateObject("Scripting.FileSystemObject")
	
	'FARR.debug(queryraw & vbnewline & querynokeyword  & vbnewline & amCommand  & vbnewline & scriptName)
	Select Case amCommand
		Case "amn"
		  dim scriptPath: scriptPath = scriptName
			
		  FARR.setState querykey,SEARCHING
		  FARR.emitResult querykey, "Create: " & scriptName, scriptPath , iconScriptCreate, FILE , IMMEDIATE_DISPLAY , 1000
		  FARR.emitResult querykey, "Record: " & scriptName, "RecordedScript" , iconScriptRecord, FILE , IMMEDIATE_DISPLAY , 900

			if fso.FolderExists( pathScripts ) then
			  Set folderScripts = fso.GetFolder( pathScripts )

				if Err.Number > 0 then
				  msgbox "Error#" & CStr(Err.Number) & ": " & Err.Description
				  Err.Clear
				End if
				
				if Err.Number > 0 then
				  msgbox "Error#" & CStr(Err.Number) & ": " & Err.Description
				  Err.Clear
				End if

			  for each fileScript in folderScripts.Files

					fileExtension = lcase(fso.GetExtensionName(fileScript.Path))
					if fileExtension = "ahk" and instr( 1, fileScript.Name , scriptName, vbTextCompare ) > 0 then

					  fileBaseName = ucase( fso.GetBaseName( fileScript.Path ) )
						thisScore = calculateScore( fileBaseName , ucase(scriptName) , fileExtension )

					  FARR.emitResult querykey , "Compile: " & fileScript.Name , fileScript.Name , iconScriptCompile , UNKNOWN , IMMEDIATE_DISPLAY , thisScore
					  FARR.notifyStateChange querykey
					end if
			  next
			end if

		  FARR.setState querykey,STOPPED
		  FARR.notifyStateChange querykey
		Case "amr" , "am"           ' Execute Script

			if fso.FolderExists( pathScripts ) then
			  Set folderScripts = fso.GetFolder( pathScripts )
			  for each fileScript in folderScripts.Files
					fileExtension = lcase(fso.GetExtensionName(fileScript.Path))
				  fileBaseName = ucase( fso.GetBaseName( fileScript.Path ) )
					if instr( 1, fileScript.Name , scriptName, vbTextCompare ) > 0 then
						thisScore = calculateScore( fileBaseName , ucase(scriptName) , fileExtension )
						if fileExtension = "ahk" then
						  FARR.emitResult querykey , "Execute: " & fileScript.Name , fileScript.Name ,  iconScriptRun  , UNKNOWN , IMMEDIATE_DISPLAY , thisScore
						elseif fileExtension = "exe"  then
						  FARR.emitResult querykey , "Run: " & fileScript.Name , fileScript.Path , iconExeRun , FILE , IMMEDIATE_DISPLAY , thisScore
						end if
					end if
				  FARR.notifyStateChange querykey
			  next
			end if
		Case "ame"            	' Edit Script
			if fso.FolderExists( pathScripts ) then
			  Set folderScripts = fso.GetFolder( pathScripts )
			  for each fileScript in folderScripts.Files
					fileExtension = lcase(fso.GetExtensionName(fileScript.Path))
				  fileBaseName = ucase( fso.GetBaseName( fileScript.Path ) )
					if fileExtension = "ahk" then
						if instr( 1, fileScript.Name , scriptName, vbTextCompare ) > 0 then
							thisScore = calculateScore( fileBaseName , ucase(scriptName) , fileExtension )
						  FARR.emitResult querykey , "Edit: " & fileScript.Name , fileScript.Name ,  iconScriptEdit  , UNKNOWN , IMMEDIATE_DISPLAY , thisScore
						end if
					end if
				  FARR.notifyStateChange querykey
			  next
			end if
		Case "amd"            	' Delete Script
			if fso.FolderExists( pathScripts ) then
			  Set folderScripts = fso.GetFolder( pathScripts )
			  for each fileScript in folderScripts.Files
					fileExtension = lcase(fso.GetExtensionName(fileScript.Path))
				  fileBaseName = ucase( fso.GetBaseName( fileScript.Path ) )
					if instr( 1, fileScript.Name , scriptName, vbTextCompare ) > 0 then
						if fileExtension = "ahk" then
							thisScore = calculateScore( fileBaseName , ucase(scriptName) , fileExtension )
						  FARR.emitResult querykey , "Delete: " & fileScript.Name , fileScript.Name ,  iconScriptDelete  , UNKNOWN , IMMEDIATE_DISPLAY , thisScore
						end if
						if fileExtension = "_ahk" then
							thisScore = calculateScore( fileBaseName , ucase(scriptName) , fileExtension )
						  FARR.emitResult querykey , "UnDelete: " & fileScript.Name , fileScript.Name ,  iconScriptDelete  , UNKNOWN , IMMEDIATE_DISPLAY , thisScore
						end if
					end if
				  FARR.notifyStateChange querykey
			  next
			end if
		Case "ami"            	' Install Script
			if fso.FolderExists( pathScripts ) then
			  Set folderScripts = fso.GetFolder( pathScripts )
			  for each fileScript in folderScripts.Files
					fileExtension = lcase(fso.GetExtensionName(fileScript.Path))
				  fileBaseName = ucase( fso.GetBaseName( fileScript.Path ) )
					if fileExtension = "ahk" then
						if instr( 1, fileScript.Name , scriptName, vbTextCompare ) > 0 then
							thisScore = calculateScore( fileBaseName , ucase(scriptName) , fileExtension )
						  FARR.emitResult querykey , "Create Shortcut: " & fileScript.Name , fileScript.Name ,  iconScriptInstall  , UNKNOWN , IMMEDIATE_DISPLAY , thisScore
						end if
					end if
				  FARR.notifyStateChange querykey
			  next
			end if
	Case else
	  msgbox "Command " & amCommand & " not implemented yet. Sorry"

	end select

end function

function onProcessTrigger(path, caption, groupname, pluginid,thispluginid,score,entrytype,voidp)

	'FARR.debug("Path: " & path & "; Caption: " & caption & "; GroupName: " & groupname & "; PluginID: " & pluginid & "; ThisPlugin: " & thispluginid & "; Score: " & score & "; EntryType: " & entrytype )
	if pluginid <> thispluginid then
		exit function
	else
	  'FARR.debug("Path: " & path & "; Caption: " & caption & "; GroupName: " & groupname & "; PluginID: " & pluginid & "; ThisPlugin: " & thispluginid & "; Score: " & score & "; EntryType: " & entrytype & "; Args: " & args & "; TriggerMode: " & triggermode)
	  dim fso: Set fso = CreateObject("Scripting.FileSystemObject")
	  dim objShell: set objShell = CreateObject("Shell.Application")

	  dim amCommand, amColon
	  amColon = instr( caption , ":")
	  amCommand = left( caption , amColon )
	  amSearchString = mid( caption , amColon + 1)
	  dim scriptCreate

	  Select Case amCommand
	    Case "Create:"
	      scriptCreate = """" & fso.BuildPath( dirCurrent , "ScriptEditor\ScriptEditor.ahk") & """"
	      ' #0000022 http://www.mitupela.net/scribbly/mantis/view.php?id=22
	      ' Fix to correct issues when no name was entered
				if path="" then path="UnNamed"
	      objShell.ShellExecute """" & pathAHK & """" , scriptCreate & """ """ & path & """ """ & dirCurrent & """"  , , , 1
			  onProcessTrigger = 3
	    Case "Compile:"
	      ScriptCreate = fso.BuildPath( dirCurrent , "scripts\")
	      scriptCreate = """" & fso.BuildPath( ScriptCreate , path ) & """"
	      iconExe = fso.BuildPath( dirCurrent , "\icons\Buuf\Script_Compile.ico")
	      objShell.ShellExecute """" & pathCompiler & """" , "/in " & scriptCreate & " /icon """ & iconExe & """" , , , 1
			  onProcessTrigger = True
	    Case "Run:"
	      ' don't need to do anything as it'll run anyway
	    Case "Delete:"
	      ScriptPath = fso.BuildPath( dirCurrent , "scripts\")
	      scriptDelete = fso.BuildPath( ScriptPath , path )
	      scriptCreate = fso.BuildPath( fso.GetParentFolderName(scriptDelete), fso.GetBaseName(scriptDelete) & "._ahk")
	    	fso.MoveFile scriptDelete , scriptCreate 
	    Case "UnDelete:"
	      ScriptPath = fso.BuildPath( dirCurrent , "scripts\")
	      scriptDelete = fso.BuildPath( ScriptPath , path )
	      scriptCreate = fso.BuildPath( fso.GetParentFolderName(scriptDelete), fso.GetBaseName(scriptDelete) & ".ahk")
	    	fso.MoveFile scriptDelete , scriptCreate 
	    Case "Execute:"
	      ScriptCreate = fso.BuildPath( dirCurrent , "scripts\")
	      scriptCreate = """" & fso.BuildPath( ScriptCreate , path ) & """"
	      objShell.ShellExecute """" & pathAHK & """" , scriptCreate , , , 1
			  onProcessTrigger = 3
	    Case "Edit:"
	      scriptCreate = """" & fso.BuildPath( dirCurrent , "ScriptEditor\ScriptEditor.ahk") & """"
	      objShell.ShellExecute """" & pathAHK & """" , scriptCreate & " """ & path & """ """ & dirCurrent & """"  , , , 1
			  onProcessTrigger = 3
			     'FARR.debug(onProcessTrigger)
	    Case "Record:"
	      scriptCreate = """" & fso.BuildPath( dirCurrent , "ScriptEditor\AMPLRecorder.ahk") & """"
	      path=Trim(amSearchString)
				if path="" then path="RecordedScript"
				path= "scriptName=" & path & " nogui=1 clicks=1 sleep=1"
	      objShell.ShellExecute """" & pathAHK & """" , scriptCreate & " " & path , , , 1
			  onProcessTrigger = 3
			Case "AMPL Help:"
			     dim hlpFile: hlpFile = fso.BuildPath( dirCurrent , "about.html")
			     FARR.setStrValue "launch", "htmlviewurl " & hlpFile
			     onProcessTrigger = True
			Case "AMPL Options:"
					 onProcessTrigger = False
			Case "Scripts Update:"
				'scriptCreate = """" & fso.BuildPath( dirCurrent , "ScriptUpdate.ahk") & """"
				'objShell.ShellExecute """" & pathAHK & """" , scriptCreate & " \update """ & dirCurrent & """"  , , , 1
					'' onProcessTrigger = 0
			   onProcessTrigger = False
			Case "Create Shortcut:"
	      ScriptCreate = fso.BuildPath( dirCurrent , "scripts\")
	      scriptCreate = """" & fso.BuildPath( ScriptCreate , path ) & """"
	      objShell.ShellExecute """" & pathAHK & """" , """" & dirCurrent & "\CreateShortCut.ahk"" " & scriptCreate  , , , 1
			  onProcessTrigger = 3
			Case ""
				Select Case path
					Case "amn","amr","ame","ami","amd"
					  newSearchString= path & " \s"
					  'msgbox "New searchString: " & newSearchString
						FARR.setStrValue "restartSearch", newSearchString
				End Select
			Case Else
				msgbox "Not implementet yet:" & vbnewline & path & vbnewline & amCommand
				onProcessTrigger = False
	  End Select
	  set fso = nothing
	  set objShell = nothing
	end if
end function


function onInit(currentDirrectory)
	dirCurrent = currentDirrectory
	dim fso: Set fso = CreateObject("Scripting.FileSystemObject")

	pathScripts = fso.BuildPath( dirCurrent , dirScripts )
	pathINI = fso.BuildPath( dirCurrent , "AMPL.ini")

  ahk_path = FARR.getIniValue(pathINI , "ampl" , "AHKDirectory")  ' main AHK directory
	if ahk_path="" then
    Call FARR.exec("settings.ahk", "", dirCurrent)
    exit function
	end if

	Call onOptionsChanged()

	set fso = nothing
	
end function

function onOptionsChanged()

	dim fso:	Set fso = CreateObject("Scripting.FileSystemObject")
  dim objShell: set objShell = CreateObject("Shell.Application")

  useIcons = FARR.getIniValue(pathINI, "ampl", "useIcons", "buuf")
  ahk_path = FARR.getIniValue(pathINI , "ampl" , "AHKDirectory")  ' main AHK directory
  preferType = FARR.getIniValue(pathINI, "ampl", "preferType", 0 )
  preferStart = FARR.getIniValue(pathINI , "ampl" , "preferStart" , 0)
  preferEnd = FARR.getIniValue(pathINI , "ampl" , "preferEnd" , 0)

	iconExeDelete=CheckIcon( def_iconExeDelete , useIcons )
	iconExeRun=CheckIcon( def_iconExeRun , useIcons )
	iconScriptCompile=CheckIcon( def_iconScriptCompile , useIcons )
	iconScriptDelete=CheckIcon( def_iconScriptDelete , useIcons )
	iconScriptEdit=CheckIcon( def_iconScriptEdit , useIcons )
	iconScriptGlue=CheckIcon( def_iconScriptGlue , useIcons )
	iconScriptInfo=CheckIcon( def_iconScriptInfo , useIcons )
	iconScriptCreate=CheckIcon( def_iconScriptCreate , useIcons )
	iconScriptInstall=CheckIcon( def_iconScriptInstall , useIcons )
	iconScriptUpdate=CheckIcon( def_iconScriptUpdate , useIcons )
	iconScriptRun=CheckIcon( def_iconScriptRun , useIcons )
	AllScriptsInfo=CheckIcon( def_AllScriptsInfo , useIcons )
	iconAllScriptsOptions=CheckIcon( def_iconAllScriptsOptions , useIcons )
	PlugInOptions=CheckIcon( def_PlugInOptions , useIcons )
	iconAMPLHelp=CheckIcon( def_iconAMPLHelp , useIcons )
	iconScriptRecord=CheckIcon( def_iconScriptRecord , useIcons)

	if fso.FolderExists( pathScripts ) then
	  if fso.fileExists( fso.BuildPath( ahk_path , "AutoHotkey.exe") ) then
	    pathAHK = fso.BuildPath( ahk_path , "AutoHotkey.exe")
	  end if
	end if
	
	if pathAHK = "" then
	  dim iCount: iCount = 0
	  dim tmp_ahk_path
	  do
	    iCount = iCount + 1
	    tmp_ahk_path = FARR.getIniValue(pathINI , "AHKlocations" , "AltLocation" & iCount)
		  if fso.fileExists( fso.BuildPath( tmp_ahk_path , "AutoHotkey.exe") ) then
		    pathAHK = fso.BuildPath( tmp_ahk_path , "AutoHotkey.exe")
		    exit do
		  end if
	    if tmp_ahk_path = "" then exit do
	  loop

	end if
	if pathAHK = "" then
		ahk_path = BrowseFolder("" , false , "Please find the folder where AHK is located:" )
		if ahk_path <> "" then
		  if fso.fileExists( fso.BuildPath( ahk_path , "AutoHotkey.exe") ) then
		    pathAHK = fso.BuildPath( ahk_path , "AutoHotkey.exe")
				dim existsSection: existsSection = findIniSection( pathINI , "[AHKlocations]")
				set iniFile = fso.OpenTextFile( pathINI , 8 , True)
				if existsSection=false then iniFile.WriteLine "[AHKlocations]"
				iniFile.WriteLine "AltLocation" & iCount & "=" & ahk_path
				iniFile.Close
				
				scriptCreate = """" & fso.BuildPath( dirCurrent , "ScriptUpdate.ahk") & """"
				objShell.ShellExecute """" & pathAHK & """" , scriptCreate , , , 1

				pathCompiler = fso.BuildPath( ahk_path , "Compiler\Ahk2Exe.exe")
			else
			  msgbox "Can't find " & fso.BuildPath( ahk_path , "AutoHotkey.exe") & " at that location!"
			end if
		end if
	end if

	set fso = nothing
end function

function showOptions
    Call FARR.exec("settings.ahk", "", dirCurrent)
end function

function onDoAdvConfig
    Call showOptions()
    onDoAdvConfig=true
end function
function findIniSection(file,section)
	findIniSection = false
	dim fso:	Set fso = CreateObject("Scripting.FileSystemObject")
	if fso.fileExists( file ) then
		dim iniFile: set iniFile = fso.OpenTextFile( file , 1 , True )
		dim iniText: iniText = iniFile.ReadAll
		if instr( iniText , section ) then findIniSection=true
		iniFile.Close
	end if
	set fso = nothing
end function
function calculateScore( fileName , scriptName , fileExtension )
	calculateScore = lngScore
	lngSearch = len(scriptName)
	if lngSearch = 0 then exit function
	if fileExtension = "ahk" Then If preferType = 2 then calculateScore = calculateScore + 50
	if fileExtension = "exe" Then If preferType = 3 then calculateScore = calculateScore + 50
	if left(fileName , lngSearch) = scriptName then calculateScore = calculateScore + preferStart
	if right(fileName , lngSearch) = scriptName then calculateScore = calculateScore + preferEnd
end function
Function GetScriptEngineInfo
   Dim s
   s = ""   ' Build string with necessary info.
   s = ScriptEngine & " Version "
   s = s & ScriptEngineMajorVersion & "."
   s = s & ScriptEngineMinorVersion & "."
   s = s & ScriptEngineBuildVersion
   GetScriptEngineInfo = s   ' Return the results.
End Function
Function BrowseFolder( myStartLocation, blnSimpleDialog , sPrompt )
' This function generates a Browse Folder dialog
' and returns the selected folder as a string.
'
' Arguments:
' myStartLocation   [string]  start folder for dialog, or "My Computer", or
'                             empty string to open in "Desktop\My Documents"
' blnSimpleDialog   [boolean] if False, an additional text field will be
'                             displayed where the folder can be selected
'                             by typing the fully qualified path
'
' Returns:          [string]  the fully qualified path to the selected folder
'
' Based on the Hey Scripting Guys article
' "How Can I Show Users a Dialog Box That Only Lets Them Select Folders?"
' http://www.microsoft.com/technet/scriptcenter/resources/qanda/jun05/hey0617.mspx
'
' Function written by Rob van der Woude
' http://www.robvanderwoude.com
    Const MY_COMPUTER   = &H11&
    Const WINDOW_HANDLE = 0 ' Must ALWAYS be 0

    Dim numOptions, objFolder, objFolderItem
    Dim objPath, objShell, strPath, strPrompt

    ' Set the options for the dialog window
    
    if sPrompt = "" then
			strPrompt = "Select a folder:"
		else
		  strPrompt = sPrompt
		end if
    If blnSimpleDialog = True Then
        numOptions = 0      ' Simple dialog
    Else
        numOptions = &H10&  ' Additional text field to type folder path
    End If
    
    ' Create a Windows Shell object
    Set objShell = CreateObject( "Shell.Application" )

    ' If specified, convert "My Computer" to a valid
    ' path for the Windows Shell's BrowseFolder method
    If UCase( myStartLocation ) = "MY COMPUTER" Then
        Set objFolder = objShell.Namespace( MY_COMPUTER )
        Set objFolderItem = objFolder.Self
        strPath = objFolderItem.Path
    Else
        strPath = myStartLocation
    End If

    Set objFolder = objShell.BrowseForFolder( WINDOW_HANDLE, strPrompt, _
                                              numOptions, strPath )

    ' Quit if no folder was selected
    If objFolder Is Nothing Then
        BrowseFolder = ""
        Exit Function
    End If

    ' Retrieve the path of the selected folder
    Set objFolderItem = objFolder.Self
    objPath = objFolderItem.Path

    ' Return the path of the selected folder
    BrowseFolder = objPath
End Function
Function CheckIcon( file_Icon , icon_Set )

	dim fso:	Set fso = CreateObject("Scripting.FileSystemObject")
	
	dim path_IconSet: path_IconSet=fso.BuildPath( dirIcons , icon_Set )
	dim path_ThisIcon: path_ThisIcon = fso.BuildPath ( path_IconSet , file_Icon )
	if fso.FileExists(fso.BuildPath(dirCurrent, path_ThisIcon) ) then
	  'CheckIcon = fso.BuildPath( CheckIcon , file_Icon )
	  CheckIcon = path_ThisIcon
	else
	  CheckIcon = fso.BuildPath( fso.BuildPath(dirCurrent, dirIcons)  , file_Icon )
	end if
	if file_Icon="Script_Recorder.ico" then
	  'FARR.Debug(CheckIcon)
	end if
End Function
