thisScript_Name=AMPL Settings Editor
title_AMPLSettings:=thisScript_Name
thisScript_Version=0.1.2
version_AMPLSettings:=thisScript_Version
thisScript_VersionDate=2009.06.14
ScriptAuthor=Perry Mowbray (scribbly)
amplWebSite=scribbly.mitupela.net\programmes\farr\ampl

/*
**********************************************************
**  AMPL Settings
**********************************************************
**
**********************************************************
** 	Version History
**  0.1.2 2009.10.12
**    + Improved checking for saved settings
**********************************************************
*/
dirIcons:=A_SCRIPTDIR . "\icons\*"
pathINI:=A_SCRIPTDIR . "\AMPL.ini"
settingsChanged=0

IniRead, oldIconGroup, %pathINI% , ampl, useIcons
IniRead, oldAHKdirectory, %pathINI%, ampl, AHKdirectory
IniRead, oldPreferType, %pathINI%, ampl, preferType
IniRead, oldPreferStart, %pathINI%, ampl, preferStart
;IniRead, oldPreferMiddle, %pathINI%, ampl, preferMiddle
IniRead, oldPreferEnd, %pathINI%, ampl, preferEnd
selectIcon=0

if (oldPreferEnd = "ERROR")
   oldPreferEnd=0
;if (oldPreferMiddle = "ERROR")
;   oldPreferMiddle=0
if (oldPreferStart = "ERROR")
   oldPreferStart=0
if (oldPreferType = "ERROR")
   {
    oldPreferType=1
    preferTypeCheckNone=Checked
   }
if (oldPreferType = 1)
    preferTypeCheckNone=Checked
if (oldPreferType = 2)
    preferTypeCheckScript=Checked
if (oldPreferType = 3)
    preferTypeCheckCompiled=Checked

;StringUpper, oldIconGroup, oldIconGroup
iconlist=
Loop, %dirIcons%, 2, 0
{
  ;StringUpper, folder, A_LOOPFILENAME
	;MsgBox %A_INDEX%`nThis Directory: [%A_LOOPFILENAME%]`nSetting: [%oldIconGroup%]
	if StrLen(iconlist)>0
		iconlist:=iconlist . "|" . A_LOOPFILENAME
	else
	  iconlist:=A_LOOPFILENAME

	if (A_LOOPFILENAME = oldIconGroup)
	{
		selectIcon=%A_INDEX%
		;msgbox, found %selectIcon%
 }
 ;else
  ;msgbox, not equal
}

;MsgBox, %selectIcon%

gui,  +ToolWindow
Gui, Add, DropDownList, x116 y10 w170 h21 R5 vIconGroup gAddChange Choose%selectIcon%, %iconlist%
Gui, Add, Text, x6 y14 w100 h20 , Use Icons
Gui, Add, Edit, x116 y40 w310 h20 vdirectoryAHK gAddChange, %oldAHKdirectory%
Gui, Add, Button, x436 y40 w30 h20 gGetDirectory, ...
Gui, Add, Text, x6 y44 w100 h20 , AHK Directory
gui, Font, bold
gui, Add, Text, x6 y66, Scoring
gui, Font, normal
gui, Add, Text, x26 y82, Prefer:
GUI, Add, Radio, x115 y82 vPreferFileType gAddChange %preferTypeCheckNone%, None
GUI, Add, Radio, x175 y82 gAddChange %preferTypeCheckScript%, Script
GUI, Add, Radio, x235 y82 gAddChange %preferTypeCheckCompiled%, Compiled
gui, Add, Text, x26 y104, Match Weight:
gui, Add, Text, x115 y104, Start
gui, Add, Edit, x145 y100 w50 h20 +Number vPreferStart gAddChange, %oldPreferStart%
gui, Add, Text, x205 y104, End
gui, Add, Edit, x245 y100 w50 h20 +Number vPreferEnd gAddChange, %oldPreferEnd%
;gui, Add, Text, x315 y104, End
;gui, Add, Edit, x345 y100 w50 h20 +Number vPreferEnd, %oldPreferEnd%

Gui, Add, Button, x116 y130 w100 h30 gSetINI, Set
Gui, Add, Button, x326 y130 w100 h30 gGuiClose, Cancel
; Generated using SmartGUI Creator 4.0
Gui, Show, x131 y91 h170 w477, %title_AMPLSettings% (%version_AMPLSettings%)
Return

AddChange:
settingsChanged+=1
Return

GuiClose:
if settingsChanged!=0
{
	MsgBox, 4, %title_AMPLSettings%, Settings have changed!`n`nContinue without saving?,
	IfMsgBox, No
		return
}
ExitApp

CheckAHK:
CheckAHK:=0
GuiControlGet, temp_directoryAHK, , directoryAHK, 
  ahk:=temp_directoryAHK . "\AutoHotKey.exe"
  IfNotExist, %ahk%
  {
		MsgBox, 0, %title_AMPLSettings%, Can't find AutoHotKey in %temp_directoryAHK%!
		GuiControl, , directoryAHK, %oldAHKdirectory% 
		CheckAHK:=1
		return
	}
Return

GetDirectory:
	SplitPath, A_AhkPath, , tryThis, , , 
  FileSelectFolder, oldAHKdirectory, *%tryThis%, 0, Select the AutoHotKey Directory
  if oldAHKdirectory=
    return
  ahk:=oldAHKdirectory . "\AutoHotKey.exe"
  IfNotExist, %ahk%
  {
		MsgBox, 0, %title_AMPLSettings%, Can't find AutoHotKey in %oldAHKdirectory%!`n%ahk%
		return
	}
  GuiControl, , directoryAHK, %oldAHKdirectory%

Return

SetINI:
gosub, CheckAHK
if CheckAHK=1
	Return
gui, Submit
;msgbox %IconGroup%
IniWrite, %IconGroup%, %pathINI%, ampl, useIcons
IniWrite, %directoryAHK%, %pathINI%, ampl, AHKdirectory
IniWrite, %PreferFileType%, %pathINI%, ampl, preferType
IniWrite, %PreferStart%, %pathINI%, ampl, preferStart
;IniWrite, %PreferMiddle%, %pathINI%, ampl, preferMiddle
IniWrite, %PreferEnd%, %pathINI%, ampl, preferEnd
DetectHiddenWindows, on
PostMessage,0x400,0,0,,FScript/AMPL
Gui, Destroy
ExitApp
Return
